% Function to compute scalar-weighed percentiles of data
function [histdata] = computePercentiles(data, scalar, xstart, xend, nbin)

    scalarSum = sum(scalar);
  

    % Compute discrete histogram values (number of bins = 1 - size(hist_x))
    if nargin < 5
        nbin = 100;
        x = linspace(min(data), max(data), nbin+1);
    else        
        x = linspace(xstart, xend, nbin+1);
    end
    bin_val = zeros(1, nbin);
    bin_x = (x(2:end) + x(1:end-1))/2;
    
    for i=1:nbin
        % compute the percentage of data in the current bin
        bin_val(i) = sum(scalar(data<x(i+1) & data >=x(i))) / scalarSum;
    end
    histdata = [bin_x; bin_val];
end