% Function to compute scalar-weighed percentiles of data
function [percentiles, percentilesData] = computePercentiles(data, scalar)

if isempty(data)
    percentiles = zeros(1,100);
else
    % Sort data
    [~, sortkey] = sort(data);
    
    % Apply the sortkey to the scalar and compute the integral of "scalar"
    scalarSorted = scalar(sortkey);
    scalarSum = sum(scalar);
    
    % Compute which percentile each data point is
    percentilesData = cumsum(scalarSorted) / scalarSum * 100;
    
    % Compute discrete percentiles
    percentiles = data(sortkey);

end